VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3090
   ClientLeft      =   165
   ClientTop       =   855
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3090
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog dlgSaveAs 
      Left            =   3240
      Top             =   1800
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
      DialogTitle     =   "Save File As"
      Filter          =   "Bitmaps|*.bmp|All Files|*.*"
   End
   Begin VB.PictureBox picCropped 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      Height          =   495
      Left            =   720
      ScaleHeight     =   435
      ScaleWidth      =   435
      TabIndex        =   1
      Top             =   120
      Visible         =   0   'False
      Width           =   495
   End
   Begin VB.PictureBox picOriginal 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      Height          =   495
      Left            =   120
      MousePointer    =   2  'Cross
      ScaleHeight     =   435
      ScaleWidth      =   435
      TabIndex        =   0
      Top             =   120
      Visible         =   0   'False
      Width           =   495
   End
   Begin MSComDlg.CommonDialog dlgOpen 
      Left            =   2640
      Top             =   1800
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
      DefaultExt      =   "*.bmp"
      DialogTitle     =   "Open File"
      Filter          =   "Image Files|*.bmp;*.jpg;*.gif|All Files|*.*"
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open..."
         Shortcut        =   ^O
      End
      Begin VB.Menu mnuFileSaveAs 
         Caption         =   "Save &As..."
         Shortcut        =   ^A
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_Selecting As Boolean
Private m_X1 As Single
Private m_Y1 As Single
Private m_X2 As Single
Private m_Y2 As Single

Private Sub Form_Load()
    picOriginal.AutoRedraw = True
    picOriginal.DrawMode = vbInvert
    picCropped.AutoRedraw = True
    m_Selecting = False
End Sub

Private Sub mnuFileOpen_Click()
    On Error Resume Next

    dlgOpen.ShowOpen
    If (Err.Number = cdlCancel) Then Exit Sub
    If (Err.Number <> 0) Then
        MsgBox "Error " & Err.Number & " selecting file." & vbCrLf & _
            Err.Description, vbOKOnly Or vbExclamation, "File Select Error"
            Exit Sub
    End If

    On Error GoTo mnuFileOpen_Error
    picOriginal.Picture = LoadPicture(dlgOpen.FileName)
    picOriginal.Visible = True
    picCropped.Visible = True
    Exit Sub

mnuFileOpen_Error:
    MsgBox "Error " & Err.Number & " opening file " & dlgOpen.FileName & "." & vbCrLf & _
        Err.Description, vbOKOnly Or vbExclamation, "File Select Error"
    Exit Sub
End Sub

Private Sub mnuFileSaveAs_Click()
    On Error Resume Next

    dlgSaveAs.ShowSave
    If (Err.Number = cdlCancel) Then Exit Sub
    If (Err.Number <> 0) Then
        MsgBox "Error " & Err.Number & " selecting file." & vbCrLf & _
            Err.Description, vbOKOnly Or vbExclamation, "File Select Error"
            Exit Sub
    End If

    On Error GoTo mnuFileSaveAs_Error
    SavePicture picCropped.Picture, dlgSaveAs.FileName
    Exit Sub

mnuFileSaveAs_Error:
    MsgBox "Error " & Err.Number & " saving file " & dlgSaveAs.FileName & "." & vbCrLf & _
        Err.Description, vbOKOnly Or vbExclamation, "File Select Error"
    Exit Sub
End Sub

' Size the form to fit.
Private Sub picOriginal_Resize()
    picCropped.Move _
        picOriginal.Left + picOriginal.Width + 120, _
        picOriginal.Top, _
        picOriginal.Width, picOriginal.Height

    Me.Width = picCropped.Left + picCropped.Width + 120 + (Width - ScaleWidth)
    Me.Height = picOriginal.Top + picOriginal.Height + 120 + (Height - ScaleHeight)
End Sub

Private Sub picOriginal_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    m_Selecting = True
    m_X1 = X
    m_Y1 = Y
    m_X2 = X
    m_Y2 = Y

    ' Draw.
    picOriginal.Line (m_X1, m_Y1)-(m_X2, m_Y2), , B
End Sub

Private Sub picOriginal_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Not m_Selecting Then Exit Sub

    ' Erase.
    picOriginal.Line (m_X1, m_Y1)-(m_X2, m_Y2), , B
    m_X2 = X
    m_Y2 = Y

    ' Draw.
    picOriginal.Line (m_X1, m_Y1)-(m_X2, m_Y2), , B
End Sub

Private Sub picOriginal_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim wid As Single
Dim hgt As Single
Dim temp As Single

    If Not m_Selecting Then Exit Sub
    m_Selecting = False

    ' Erase.
    picOriginal.Line (m_X1, m_Y1)-(m_X2, m_Y2), , B

    ' Make pt2 > pt1.
    If m_X1 > m_X2 Then
        temp = m_X1
        m_X1 = m_X2
        m_X2 = temp
    End If
    If m_Y1 > m_Y2 Then
        temp = m_Y1
        m_Y1 = m_Y2
        m_Y2 = temp
    End If

    wid = m_X2 - m_X1
    hgt = m_Y2 - m_Y1
    If (wid = 0) Or (hgt = 0) Then Exit Sub

    ' Size the result.
    picCropped.Width = wid + (picCropped.Width - picCropped.ScaleWidth)
    picCropped.Height = hgt + (picCropped.Height - picCropped.ScaleHeight)

    ' Copy the selected area.
    picCropped.PaintPicture picOriginal.Picture, 0, 0, wid, hgt, m_X1, m_Y1, wid, hgt
    picCropped.Picture = picCropped.Image
End Sub
